#include "tnotify.h"
#include "QtGui"
#include "tnotifywindow.h"
#include "iostream"

TNotify::TNotify(QObject *parent) :
    QObject(parent),
    notifyNum(0)
{
}

void TNotify::newNotify(QString Title, QString Text){
    notifyList.append(new TNotifyWindow(Title, Text, notifyList.count()));
    QObject::connect(notifyList.last(), SIGNAL(requestDelete(TNotifyWindow*)), this, SLOT(deleteNotify(TNotifyWindow*)));
    std::cout << "Notification number: " << notifyList.count() << std::endl;
    notifyNum++;
}

void TNotify::deleteNotify(TNotifyWindow* notify){

    std::cout << "Start moving notifications..." << std::endl;
    std::cout << "Hiding..." << std::endl;
    //notify->hide();
    notify->close();
    for (int i=notifyList.count()-1; i >=0;  i--){
        if (notifyList.at(i)->isHidden()){
            for (int j=notifyList.count()-1; j >= i+1; j--){
                std::cout << "Moving..." << std::endl;
                QPropertyAnimation* anima = new QPropertyAnimation(notifyList.at(j), "geometry");
                anima->setDuration(300);
                anima->setStartValue(notifyList.at(j)->geometry());
                int newY = notifyList.at(j-1)->y() + notifyList.at(j-1)->height() - notifyList.at(j)->height();
                anima->setEndValue(QRect(notifyList.at(j)->x(),newY,  notifyList.at(j)->width(),notifyList.at(j)->height()));
                anima->start();
                QEventLoop loop;
                QObject::connect(anima, SIGNAL(finished()), &loop, SLOT(quit()));
                loop.exec();
            }
        }
    }
    std::cout << "Erasing..." << std::endl;
    //notify->close();
    notifyList.removeOne(notify);
    std::cout << "Remove done." << std::endl;
}
